=== debian/changelog ===
openshadinglanguage (1.4.2-0irie1~precise1) precise; urgency=medium

  * New upstream release
  * debian/testshade.1:
    - Add new options: --debuguninit, --options
    - Update description: --debugnan

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Tue, 20 May 2014 19:58:38 +0900

openshadinglanguage (1.4.1-0irie4~trusty1) trusty; urgency=low

  * debian/rules:
    - Add compiler/linker options to fix FTBFS on some distributions:
        Preciese: -DSPECIAL_COMPILE_FLAGS="-Wno-error=strict-overflow -O2"
        Trusty:   -DEXTRA_OSLEXEC_LIBRARIES="tinfo"

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 26 Mar 2014 00:34:39 +0900

openshadinglanguage (1.4.1-0irie3~saucy1) saucy; urgency=low

  * Use LLVM static library:
    - This is workaround for issue that graphical application such as
      Blender crashes if using Gallium3D-based graphics driver

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Tue, 25 Mar 2014 19:07:50 +0900

openshadinglanguage (1.4.1-0irie2~trusty1) trusty; urgency=low

  * Add patch 040_support_llvm34 to fix FTBFS on Trusty:
    - Backported from master branch 08c7eb99c8ef85426ede781c9d20a398c3efeb33

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 05 Mar 2014 21:20:57 +0900

openshadinglanguage (1.4.1-0irie1~saucy1) saucy; urgency=low

  * New upstream release
  * Move to RB-1.4 branch:
    - Rename shared library package to libopenshadinglanguage1.4
  * Update for some upstream changes:
    - CMakeLists.txt was moved from SRCDIR/src to SRCDIR
    - shaders were moved from BLDDIR/shaders to BLDDIR/src/shaders
  * debian/copyright:
    - Update copyright years

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 01 Jan 2014 11:05:52 +0900

openshadinglanguage (1.3.3-0irie1~saucy2) saucy; urgency=low

  * Build with OpenImageIO 1.2.3

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 06 Nov 2013 22:02:07 +0900

openshadinglanguage (1.3.3-0irie1~raring1) raring; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 10 Aug 2013 22:40:26 +0900

openshadinglanguage (1.3.2-0irie1~raring1) raring; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sun, 30 Jun 2013 22:54:17 +0900

openshadinglanguage (1.3.1-0irie1~raring1) raring; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Mon, 10 Jun 2013 14:26:14 +0900

openshadinglanguage (1.3.0-0irie2~raring1) raring; urgency=low

  * Add patch 010_multiarch_findlibs:
    - Fix FTBFS on Raring (libilmbase not found)

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Fri, 08 Mar 2013 01:17:31 +0900

openshadinglanguage (1.3.0-0irie1~quantal1) quantal; urgency=low

  * New upstream release
  * Move to RB-1.3 branch:
    - Rename shared library package to libopenshadinglanguage1.3
    - Move runtime headers and example shaders to /usr/share/OSL-1.3/shaders
  * Remove patch 010_fix_FTBFS:
    - Fixed upstream
  * debian/docs:
    - Rename README to README.md
  * debian/copyright:
    - Update copyright years

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 16 Feb 2013 14:34:46 +0900

openshadinglanguage (1.2-0irie4~quantal1) quantal; urgency=low

  * debian/control:
    - Fix descriptions
  * Move runtime headers and example shaders:
    - /usr/share/OSL/shaders -> /usr/share/OSL-1.2/shaders
    - Modify debian/rules, debian/libopenshadinglanguage1.2.install,
      debian/oslc.1, and patch 020_fix_implicit_include
  * Modify patch 010_fix_FTBFS:
    - Use cast operator (int) rather than "z" prefix

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Mon, 05 Nov 2012 16:42:21 +0900

openshadinglanguage (1.2-0irie3~quantal1) quantal; urgency=low

  * Modify patch 010_fix_FTBFS:
    - Grr, more fixes for i386 build failure...

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 03 Nov 2012 01:45:32 +0900

openshadinglanguage (1.2-0irie2~quantal1) quantal; urgency=low

  * Modify patch 010_fix_FTBFS:
    - Fix FTBFS on i386 (OSL issue #160)

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Fri, 02 Nov 2012 23:24:04 +0900

openshadinglanguage (1.2-0irie1~quantal1) quantal; urgency=low

  * Initial release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Thu, 01 Nov 2012 23:30:03 +0900
