=== debian/control ===
Source: openshadinglanguage
Priority: extra
Maintainer: IRIE Shinsuke <irieshinsuke@yahoo.co.jp>
Build-Depends: debhelper (>= 8.0.0), cmake, chrpath,
	       flex, bison, llvm-dev (>= 3.0), clang (>= 3.0),
	       libopenexr-dev, libopenimageio-dev,
	       libboost-filesystem-dev, libboost-regex-dev,
	       libboost-system-dev, libboost-thread-dev, libtbb-dev
Standards-Version: 3.9.3
Section: graphics
Homepage: https://github.com/imageworks/OpenShadingLanguage

Package: openshadinglanguage
Architecture: any
Depends: libopenshadinglanguage1.4 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: openshadinglanguage-doc
Description: Small but rich language for programmable shading - compiler
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains command line programs such as OSL compiler.

Package: libopenshadinglanguage-dev
Section: libdevel
Architecture: any
Depends: libopenshadinglanguage1.4 (= ${binary:Version}), ${misc:Depends}
Description: Small but rich language for programmable shading - development
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains header files for building programs that provides
 OSL compiler or OSL shading system.

Package: libopenshadinglanguage1.4
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: openshadinglanguage-doc
Description: Small but rich language for programmable shading - runtime
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package includes shared libraries and runtime data for
 compiling/running OSL programs.  Also includes example shader scripts.

Package: openshadinglanguage-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Small but rich language for programmable shading - document
 Open Shading Language (OSL) is a small but rich language for
 programmable shading in advanced renderers and other applications, ideal
 for describing materials, lights, displacement, and pattern generation.
 .
 OSL was developed by Sony Pictures Imageworks for use in its in-house
 renderer used for feature film animation and visual effects. The
 language specification was developed with input by other visual effects
 and animation studios who also wish to use it.
 .
 OSL is robust and production-proven, and was the exclusive shading
 system for big VFX films such as "Men in Black 3: and "The Amazing
 Spider-Man," animated features such as "Hotel Transylvania", and several
 other films currently in production.
 .
 This package contains a manual that describes the language specification
 of OSL.
